var yaml = require('js-yaml');
var React = require('react');

var Configure = require('../components/Configure.jsx');
var configureFactory = React.createFactory(Configure);

module.exports = {
  Configure: Configure,

  renderYml: function(yml, component, changeHandler) {
    var doc = yaml.safeLoad(yml);
    React.render(
      configureFactory({groups: doc.config, handleChange: changeHandler}),
      component
    );
  },

  renderYmlToString: function(yml, cb) {
    var doc;
    try {
      doc = yaml.safeLoad(yml);
    } catch (exc) {
      cb(exc, null);
    }
    var cofn = configureFactory({groups: doc.config});
    var html = React.renderToString(cofn);
    cb(null, html);
  },
};
